book/urls.py
from django.urls import path

from . import views

app_name = 'book'

urlpatterns = [
    path('book/', views.index, name='index'),
    path('data/', views.fungsi_data, name='fungsi_data')

    
]

matkul/urls.py
from django.urls import path

from . import views

app_name = 'matkul'

urlpatterns = [
    path('', views.index, name='index'),
    path("<int:matkul_id>/", views.matkul, name="matkul"),
    path("create/", views.matkul_create, name="create_matkul"),
    path("<int:matkul_id>/delete/", views.matkul_delete, name="delete_matkul")
]

story4/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('matkul/', include('matkul.urls')),
    path('tasks/', include('tasks.urls')),
    path('accordion/', include('accordion.urls')),
    path('', include('book.urls')),
    path('', include('account.urls')),


]

matkul/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator 

# Create your models here.
class Matkul(models.Model):
    name = models.CharField(max_length=64)
    dosen = models.CharField(max_length=64)
    sks = models.PositiveIntegerField(default=1, validators=[MinValueValidator(1), MaxValueValidator(6)])
    desc = models.TextField()
    semester = models.CharField(max_length=9)
    ruang = models.CharField(max_length=20)

def __str__(self):
    return f"{self.name} : {self.dosen}, {self.sks} sks, {self.desc}, {self.semester}, {self.ruang}"

matkul/forms.py
from django.db import models
from django import forms
from .models import Matkul

class formMatkul(forms.ModelForm):
    class Meta:
        model = Matkul
        fields = ['name', 'dosen', 'sks', 'desc', 'semester', 'ruang']

matkul/views.py
from django.shortcuts import get_object_or_404, render, redirect
from.models import Matkul
from .forms import formMatkul

# Create your views here.

def index(request):
    return render(request, "matkul/index.html",{
        "matkul": Matkul.objects.all()
    })

def matkul(request, matkul_id):
    matkul = Matkul.objects.get(pk=matkul_id)
    return render(request, "matkul/matkul.html", {
        "matkul": matkul
    })

def matkul_create(request):
    form = formMatkul(request.POST or None)
    if form.is_valid():
        form.save()
        return redirect('../')
    context = {'form': form}
    return render(request, "matkul/matkul_create.html", context)

def matkul_delete(request, matkul_id):
    obj=get_object_or_404(Matkul, pk=matkul_id)
    if request.method == "POST":
        obj.delete()
        return redirect('../../')
    context = {"object" : obj}
    return render(request, "matkul/matkul_delete.html", context)

matkul/templates/matkul/index.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Matkul</title>
{% endblock meta %}
{% block content %}
<div class="header-container">
    <br><br>
    <p id="welcome">Welcome, Fina!</p>
    <p id="photo-gallery">catat jadwal kuliah mu di sini :)</p>
    <br>
</div>
<div class="add">
    <div class="text-center">
        <div class="button">
            <a class="btn btn-primary" href="{% url 'matkul:create_matkul' %}" role="button">Add Matkul</a>
            <br><br><br>
        </div>
    </div>
</div>
<div class="listnya">
    <div class="container">
        <div class="row">
            <div class="row col-md-12">
                {%for items in matkul %}
                    <div class="list-group">
                        <a href="{% url 'matkul:matkul' items.id %}" class="list-group-item list-group-item-action">{{ items.name }}</a>
                    </div>
                    <a class="btn btn-danger" href="{% url 'matkul:delete_matkul' items.id %}" role="button">Delete</a>
                    <br><br><br>
                {% endfor %}
            </div>
        </div> 
    </div>
</div>
<br><br><br><br><br><br><br><br>
{% endblock content %}

matkul/templates/matkul/matkul.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Detail Matkul</title>
{% endblock meta %}
{% block content %}
<div class="header-container">
    <br><br>
    <p id="welcome">{{ matkul.name }}</p>
    <br><br>
</div>
<div class="tulisan">
    <div class="container">
        <div class="row">
            <div class="row col-md-12">
                <ul class="list-group list-group-flush">
                    <li class="list-group-item">Nama Dosen : {{ matkul.dosen }}</li>
                    <li class="list-group-item">Jumlah SKS : {{ matkul.sks }}</li>
                    <li class="list-group-item">Deskripsi : {{ matkul.desc }}</li>
                    <li class="list-group-item">Semester : {{ matkul.semester }}</li>
                    <li class="list-group-item">Ruang Kelas : {{ matkul.ruang }}</li>
                </ul>
                <div class="button">
                    <a class="btn btn-primary" href="{% url 'matkul:index' %}" role="button">Back to the list</a>
                    <br><br><br>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

matkul/templates/matkul/matkul_create.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Create</title>
{% endblock meta %}
{% block content %}
<div class="header-container">
    <br><br>
    <p id="welcome">Add Matkul</p>
    <br><br><br>
</div>
<div class="container">
    <div class="row">
        <div class="row col-md-12">
            <form method="POST"> {% csrf_token %}
                {{ form.as_p }}
                <br>
                <input class="btn btn-success btn-lg active" role="button" type="submit" value="Save">
            </form>
            <div class="button">
                <br><br><br>
                <a class="btn btn-primary" href="{% url 'matkul:index' %}" role="button">Back to the list</a>
                <br><br><br>
            </div>
        </div> 
    </div>
</div>

{% endblock content %}

matkul/templates/matkul/matkul_delete.html
{% extends 'base.html' %}
{% load static %}
{% block meta %}
<title>Delete?</title>
{% endblock meta %}
{% block content %}
<form action='.' method='POST'> 
    {% csrf_token %}
    <div class="header-container">
        <br><br><br><br><br><br><br><br><br>
        <p id="welcome">You want to delete {{ object.name}}? Are you sure?</p>
        <br><br><br>
    </div>
    <div class="text-center">
        <p>
            <input class="btn btn-primary btn-lg active" role="button" type="submit" value="Yes, Please :)">
            <a href="../../" class="btn btn-secondary btn-lg active" role="button" aria-pressed="true">Nahhhhh :'(</a>
        </p>
    </div>
</form>
<br><br><br><br><br><br>
{% endblock content %}